package org.iotivity.bridge.homeserver.handler.client;

import org.iotivity.OCEventCallbackResult;
import org.iotivity.OCTriggerHandler;
import org.iotivity.bridge.homeserver.BridgeServerActivity;
import org.iotivity.bridge.homeserver.model.Light;
import org.iotivity.bridge.homeserver.utils.Utils;
import org.iotivity.oc.OcRemoteResource;
import org.iotivity.oc.OcUtils;

public class StopObserveTriggerHandler implements OCTriggerHandler {

    private static final String TAG = StopObserveTriggerHandler.class.getSimpleName();

    private BridgeServerActivity activity;
    private Light light;
    private OcRemoteResource resource ;

    public StopObserveTriggerHandler(BridgeServerActivity activity, OcRemoteResource resource, Light light) {
        this.activity = activity;
        this.light = light;
        this.resource = resource ;
    }

    @Override
    public OCEventCallbackResult handler() {
        activity.msg("Stopping OBSERVE");
        activity.printLine();
        OcUtils.stopObserve(resource.getUri(), Utils.getCoapsEndpoint(resource.getEndpoints()));
        return OCEventCallbackResult.OC_EVENT_DONE;
    }
}
