package org.iotivity.bridge.homeserver.model;

import org.iotivity.oc.OcCborException;
import org.iotivity.oc.OcRepresentation;

import java.util.ArrayList;
import java.util.List;

public class VirtualOCFDevice {

    // Virtual OCF Device (VOD) resource names
    static public final String NAME_KEY = "n";
    static public final String ECONAME_KEY = "econame";
    static public final String DI_KEY = "di";

    // Virtual OCF Device variables
    private String name;
    private String econame;
    private String di ;
    private boolean discovered ;
    private boolean added_to_bridge ;
    private boolean isOwned ;
    private int index ;

    public VirtualOCFDevice(int vod_index, String name, String econame, String virtual_di) {
        this.index = vod_index;
        this.name = name;
        this.econame = econame ;
        this.di = virtual_di ;
    }

    public int getVODIndex() {
        return index;
    }
    public void setVODIndex(int vod_index) {
        this.index = vod_index;
    }

    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }

    public String getEcoName() {
        return econame;
    }
    public void setEcoName(String econame) {
        this.econame = econame;
    }

    public String getVirtualDeviceId() {
        return di;
    }
    public void setVirtualDeviceId(String di) {
        this.di = di;
    }

    public boolean isDiscovered() {
        return discovered;
    }
    public void setDiscovered(boolean discovered) {
        this.discovered = discovered;
    }

    public boolean isAddedToBridge() {
        return added_to_bridge;
    }
    public void setAddedToBridge(boolean added) {
        this.added_to_bridge = added;
    }

    public boolean isOwned() {
        return isOwned;
    }
    public void setOwned(boolean owned) {
        this.isOwned = owned;
    }

    @Override
    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("VOD ["+index+"]");
        sb.append(", name="+name);
        sb.append(", econame="+econame);
        sb.append(", vod_di="+di);
        sb.append(", isDiscoverd="+discovered);
        sb.append(", addedToBridge="+added_to_bridge);
        sb.append(", isOwned="+isOwned);

        return sb.toString();
    }
}
